using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_HideTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 56);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(512, 464);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(88, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(176, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "AllowEdit = True";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(280, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(200, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "AllowEdit = false";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 558);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private int numberParentRows = 50;
		

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID",typeof(int))); //lower case p
			dt.Columns.Add(new DataColumn("ParentName",typeof(int)));
			dt.Columns.Add(new DataColumn("ParentDec",typeof(int)));
			dt.Columns.Add(new DataColumn("check", typeof(bool)));

			dt.Columns.Add(new DataColumn("Column1",typeof(int)));
			dt.Columns.Add(new DataColumn("Column2", typeof(bool)));

			dt.Columns.Add(new DataColumn("Column3",typeof(int)));
			dt.Columns.Add(new DataColumn("Column4", typeof(string)));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = i;
				dr[2] = i*12;
				dt.Rows.Add(dr);
			}

			return dt;
		}

		
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			this.gridGroupingControl1.DataSource = parentTable;

			 
			this.gridGroupingControl1.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.ReadOnly = true;    
			this.gridGroupingControl1.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.BackColor = Color.Pink  ;

			this.gridGroupingControl1.TableDescriptor.Columns[4].Appearance.AnyRecordFieldCell.ReadOnly = true;
			this.gridGroupingControl1.TableDescriptor.Columns[4].Appearance.AnyRecordFieldCell.BackColor = Color.Pink  ;

			this.gridGroupingControl1.TableControlCurrentCellStartEditing +=new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellStartEditing);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableDescriptor.AllowEdit = true;  
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.TableDescriptor.AllowEdit = false;
		}

		private void gridGroupingControl1_TableControlCurrentCellStartEditing(object sender, GridTableControlCancelEventArgs e)
		{
			int field = e.TableControl.TableDescriptor.ColIndexToField(e.TableControl.CurrentCell.ColIndex);         
			e.Inner.Cancel = e.TableControl.TableDescriptor.Columns[field].Appearance.AnyRecordFieldCell.ReadOnly;  
		}
	}
}
